
####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was Config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../../../../../../" ABSOLUTE)

# Use original install prefix when loaded through a "/usr move"
# cross-prefix symbolic link such as /lib -> /usr/lib.
get_filename_component(_realCurr "${CMAKE_CURRENT_LIST_DIR}" REALPATH)
get_filename_component(_realOrig "/usr/lib/python3/dist-packages/tomopy/util/extern/cmake/libtomo" REALPATH)
if(_realCurr STREQUAL _realOrig)
  set(PACKAGE_PREFIX_DIR "/usr")
endif()
unset(_realOrig)
unset(_realCurr)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

include("${CMAKE_CURRENT_LIST_DIR}/libtomoTargets.cmake")
set(libtomo_LIBRARIES) # clear variable

foreach(_TARG libtomo::tomo-misc ;libtomo::tomo-prep ;libtomo::tomo-recon ;libtomo::tomo-gridrec ;libtomo::tomo-accel )
    # there is a check in the build-tree that ensures this is a valid string manip
    string(REPLACE "libtomo::tomo-" "" _TARG_BASIC "${_TARG}")

    if(NOT TARGET ${_TARG})
        # if the target doesn't exist add it to the libtomo_FIND_COMPONENTS
        # and set that it is not found so check_required_components will fail
        list(APPEND libtomo_FIND_COMPONENTS ${_TARG_BASIC})
        set(libtomo_${_TARG_BASIC}_FOUND 0)
    else()
        set(libtomo_${_TARG_BASIC}_FOUND 1)
        if(NOT libtomo_FIND_COMPONENTS)
            # if COMPONENTS are not specified, always add to libtomo_LIBRARIES
            list(APPEND libtomo_LIBRARIES ${_TARG})
        elseif(${_TARG_BASIC} IN_LIST libtomo_FIND_COMPONENTS)
            # if COMPONENTS was specified, add only if in COMPONENTS list
            list(APPEND libtomo_LIBRARIES ${_TARG})
        endif()
    endif()
endforeach()

check_required_components(libtomo)

if(libtomo_FOUND)
    add_library(libtomo::libtomo INTERFACE IMPORTED)
    target_link_libraries(libtomo::libtomo INTERFACE ${libtomo_LIBRARIES})
endif()
